import {
  ObjectTypeDefinitionNode,
  InputObjectTypeDefinitionNode,
  EnumTypeDefinitionNode,
  InterfaceTypeDefinitionNode,
  ScalarTypeDefinitionNode,
  UnionTypeDefinitionNode,
} from '../graphql';
import { ObjectTypeComposer } from '../ObjectTypeComposer';
import { InputTypeComposer } from '../InputTypeComposer';
import { EnumTypeComposer } from '../EnumTypeComposer';
import { InterfaceTypeComposer } from '../InterfaceTypeComposer';
import { ScalarTypeComposer } from '../ScalarTypeComposer';
import { UnionTypeComposer } from '../UnionTypeComposer';

/**
 * Get astNode for ObjectTypeComposer.
 */
export function getObjectTypeDefinitionNode(
  tc: ObjectTypeComposer<any, any>
): ObjectTypeDefinitionNode;

/**
 * Get astNode for InputTypeComposer.
 */
export function getInputObjectTypeDefinitionNode(
  tc: InputTypeComposer<any>
): InputObjectTypeDefinitionNode;

/**
 * Get astNode for EnumTypeComposer.
 */
export function getEnumTypeDefinitionNode(tc: EnumTypeComposer<any>): EnumTypeDefinitionNode;

/**
 * Get astNode for InterfaceTypeComposer.
 */
export function getInterfaceTypeDefinitionNode(
  tc: InterfaceTypeComposer<any, any>
): InterfaceTypeDefinitionNode;

/**
 * Get astNode for ScalarTypeComposer.
 */
export function getScalarTypeDefinitionNode(tc: ScalarTypeComposer<any>): ScalarTypeDefinitionNode;

/**
 * Get astNode for ScalarTypeComposer.
 */
export function getUnionTypeDefinitionNode(
  tc: UnionTypeComposer<any, any>
): UnionTypeDefinitionNode;
