"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  schemaComposer: true,
  sc: true,
  graphql: true,
  SchemaComposer: true,
  ObjectTypeComposer: true,
  InputTypeComposer: true,
  EnumTypeComposer: true,
  ScalarTypeComposer: true,
  InterfaceTypeComposer: true,
  UnionTypeComposer: true,
  Resolver: true,
  TypeStorage: true,
  TypeMapper: true,
  NonNullComposer: true,
  ListComposer: true,
  ThunkComposer: true,
  GraphQLDate: true,
  GraphQLBuffer: true,
  GraphQLJSON: true,
  GraphQLJSONObject: true,
  getProjectionFromAST: true,
  getFlatProjectionFromAST: true,
  toInputObjectType: true,
  convertInputObjectField: true,
  toDottedObject: true,
  createThunkedObjectProxy: true,
  deepmerge: true,
  filterByDotPaths: true,
  pluralize: true,
  dedent: true
};
Object.defineProperty(exports, "SchemaComposer", {
  enumerable: true,
  get: function () {
    return _SchemaComposer.SchemaComposer;
  }
});
Object.defineProperty(exports, "ObjectTypeComposer", {
  enumerable: true,
  get: function () {
    return _ObjectTypeComposer.ObjectTypeComposer;
  }
});
Object.defineProperty(exports, "InputTypeComposer", {
  enumerable: true,
  get: function () {
    return _InputTypeComposer.InputTypeComposer;
  }
});
Object.defineProperty(exports, "EnumTypeComposer", {
  enumerable: true,
  get: function () {
    return _EnumTypeComposer.EnumTypeComposer;
  }
});
Object.defineProperty(exports, "ScalarTypeComposer", {
  enumerable: true,
  get: function () {
    return _ScalarTypeComposer.ScalarTypeComposer;
  }
});
Object.defineProperty(exports, "InterfaceTypeComposer", {
  enumerable: true,
  get: function () {
    return _InterfaceTypeComposer.InterfaceTypeComposer;
  }
});
Object.defineProperty(exports, "UnionTypeComposer", {
  enumerable: true,
  get: function () {
    return _UnionTypeComposer.UnionTypeComposer;
  }
});
Object.defineProperty(exports, "Resolver", {
  enumerable: true,
  get: function () {
    return _Resolver.Resolver;
  }
});
Object.defineProperty(exports, "TypeStorage", {
  enumerable: true,
  get: function () {
    return _TypeStorage.TypeStorage;
  }
});
Object.defineProperty(exports, "TypeMapper", {
  enumerable: true,
  get: function () {
    return _TypeMapper.TypeMapper;
  }
});
Object.defineProperty(exports, "NonNullComposer", {
  enumerable: true,
  get: function () {
    return _NonNullComposer.NonNullComposer;
  }
});
Object.defineProperty(exports, "ListComposer", {
  enumerable: true,
  get: function () {
    return _ListComposer.ListComposer;
  }
});
Object.defineProperty(exports, "ThunkComposer", {
  enumerable: true,
  get: function () {
    return _ThunkComposer.ThunkComposer;
  }
});
Object.defineProperty(exports, "GraphQLDate", {
  enumerable: true,
  get: function () {
    return _type.GraphQLDate;
  }
});
Object.defineProperty(exports, "GraphQLBuffer", {
  enumerable: true,
  get: function () {
    return _type.GraphQLBuffer;
  }
});
Object.defineProperty(exports, "GraphQLJSON", {
  enumerable: true,
  get: function () {
    return _type.GraphQLJSON;
  }
});
Object.defineProperty(exports, "GraphQLJSONObject", {
  enumerable: true,
  get: function () {
    return _type.GraphQLJSONObject;
  }
});
Object.defineProperty(exports, "getProjectionFromAST", {
  enumerable: true,
  get: function () {
    return _projection.getProjectionFromAST;
  }
});
Object.defineProperty(exports, "getFlatProjectionFromAST", {
  enumerable: true,
  get: function () {
    return _projection.getFlatProjectionFromAST;
  }
});
Object.defineProperty(exports, "toInputObjectType", {
  enumerable: true,
  get: function () {
    return _toInputObjectType.toInputObjectType;
  }
});
Object.defineProperty(exports, "convertInputObjectField", {
  enumerable: true,
  get: function () {
    return _toInputObjectType.convertInputObjectField;
  }
});
Object.defineProperty(exports, "toDottedObject", {
  enumerable: true,
  get: function () {
    return _toDottedObject.toDottedObject;
  }
});
Object.defineProperty(exports, "createThunkedObjectProxy", {
  enumerable: true,
  get: function () {
    return _createThunkedObjectProxy.createThunkedObjectProxy;
  }
});
Object.defineProperty(exports, "deepmerge", {
  enumerable: true,
  get: function () {
    return _deepmerge.deepmerge;
  }
});
Object.defineProperty(exports, "filterByDotPaths", {
  enumerable: true,
  get: function () {
    return _filterByDotPaths.filterByDotPaths;
  }
});
Object.defineProperty(exports, "pluralize", {
  enumerable: true,
  get: function () {
    return _pluralize.pluralize;
  }
});
Object.defineProperty(exports, "dedent", {
  enumerable: true,
  get: function () {
    return _dedent.dedent;
  }
});
exports.graphql = exports.sc = exports.schemaComposer = void 0;

var graphql = _interopRequireWildcard(require("./graphql"));

exports.graphql = graphql;

var _SchemaComposer = require("./SchemaComposer");

var _ObjectTypeComposer = require("./ObjectTypeComposer");

var _InputTypeComposer = require("./InputTypeComposer");

var _EnumTypeComposer = require("./EnumTypeComposer");

var _ScalarTypeComposer = require("./ScalarTypeComposer");

var _InterfaceTypeComposer = require("./InterfaceTypeComposer");

var _UnionTypeComposer = require("./UnionTypeComposer");

var _Resolver = require("./Resolver");

var _TypeStorage = require("./TypeStorage");

var _TypeMapper = require("./TypeMapper");

var _NonNullComposer = require("./NonNullComposer");

var _ListComposer = require("./ListComposer");

var _ThunkComposer = require("./ThunkComposer");

var _type = require("./type");

var _projection = require("./utils/projection");

var _toInputObjectType = require("./utils/toInputObjectType");

var _misc = require("./utils/misc");

Object.keys(_misc).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _misc[key];
    }
  });
});

var _typeHelpers = require("./utils/typeHelpers");

Object.keys(_typeHelpers).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _typeHelpers[key];
    }
  });
});

var _is = require("./utils/is");

Object.keys(_is).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _is[key];
    }
  });
});

var _definitions = require("./utils/definitions");

Object.keys(_definitions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _definitions[key];
    }
  });
});

var _graphqlVersion = require("./utils/graphqlVersion");

Object.keys(_graphqlVersion).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _graphqlVersion[key];
    }
  });
});

var _schemaPrinter = require("./utils/schemaPrinter");

Object.keys(_schemaPrinter).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _schemaPrinter[key];
    }
  });
});

var _toDottedObject = require("./utils/toDottedObject");

var _createThunkedObjectProxy = require("./utils/createThunkedObjectProxy");

var _deepmerge = require("./utils/deepmerge");

var _filterByDotPaths = require("./utils/filterByDotPaths");

var _pluralize = require("./utils/pluralize");

var _dedent = require("./utils/dedent");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const schemaComposer = new _SchemaComposer.SchemaComposer();
exports.schemaComposer = schemaComposer;
const sc = schemaComposer;
exports.sc = sc;